VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SplitterCtrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'by Th. Fssl, fuessl@cae-software.com
'http://www.cae-software.com/vb/

'aufbauend auf
'"Adding a Vertical Splitter Bar", Randy Birch
'http://www.codeguru.com/vb/Forms/

Private position#, dx#
Private status%
Private SplitterCtrl As Control
Private ReferenzCtrl As Control

Public MinWidth%
Public BorderWidth%
Public RealTime As Boolean

Event Resize()

Public Sub Mouse(x As Single, Optional Button As Integer = 0)
    
If status% = 1 And (Button And vbLeftButton) = vbLeftButton And x <> position# Then
   sx = SplitterCtrl.Left + x - dx#
   If sx < BorderWidth% + MinWidth% Then sx = BorderWidth% + MinWidth%
   If sx > SplitterCtrl.Parent.ScaleWidth - BorderWidth% - SplitterCtrl.Width - MinWidth% Then sx = SplitterCtrl.Parent.ScaleWidth - BorderWidth% - SplitterCtrl.Width - MinWidth%
   SplitterCtrl.Move sx, Top(), SplitterCtrl.Width, Height()
   position# = x: status% = 1
   If RealTime Then RaiseEvent Resize
ElseIf status% = 1 And (Button And vbLeftButton) = 0 Then
   SplitterCtrl.BackColor = &H8000000F
   status% = 0
   RaiseEvent Resize
ElseIf status% = 0 And (Button And vbLeftButton) = vbLeftButton Then
   SplitterCtrl.BackColor = &H808080
   position# = x: dx# = x: status% = 1
End If

End Sub

Public Sub Init(c As Control, Optional R As Control = Nothing)

Set SplitterCtrl = c
SplitterCtrl.BorderStyle = 0
SplitterCtrl.BackColor = &H8000000F
SplitterCtrl.MousePointer = 9

Set ReferenzCtrl = R

End Sub

Private Sub Class_Initialize()

status% = 0
Set SplitterCtrl = Nothing
Set ReferenzCtrl = Nothing
MinWidth% = 0
BorderWidth% = 80
RealTime = False

End Sub

Private Property Get VisibleLeft() As Integer

VisibleLeft = SplitterCtrl.Left > BorderWidth%

End Property

Private Property Get VisibleRight() As Integer

VisibleRight = SplitterCtrl.Left < SplitterCtrl.Parent.ScaleWidth - BorderWidth% - SplitterCtrl.Width

End Property

Private Property Get WidthLeft() As Integer

breite% = SplitterCtrl.Parent.ScaleWidth - BorderWidth% * 2
If VisibleLeft() = 0 Then
   WidthLeft = 0
ElseIf VisibleRight() = 0 Then
   If breite% < 0 Then breite% = 0
   WidthLeft = breite%
Else
   If SplitterCtrl.Left < BorderWidth% Then SplitterCtrl.Left = BorderWidth%
   WidthLeft = SplitterCtrl.Left - BorderWidth%
End If

End Property

Private Property Get WidthRight() As Integer

breite% = SplitterCtrl.Parent.ScaleWidth - BorderWidth% * 2
If VisibleLeft() = 0 Then
   If breite% < 0 Then breite% = 0
   WidthRight = breite%
ElseIf VisibleRight() = 0 Then
   WidthRight = 0
Else
   breite% = breite% - (SplitterCtrl.Left - BorderWidth%) - SplitterCtrl.Width
   If breite% < 0 Then breite% = 0
   WidthRight = breite%
End If

End Property

Private Property Get Left() As Integer

If VisibleLeft() = 0 Then
   Left = BorderWidth% - SplitterCtrl.Width
ElseIf VisibleRight() = 0 Then
   Left = SplitterCtrl.Parent.ScaleWidth - BorderWidth%
Else
   Left = SplitterCtrl.Left
End If

End Property

Private Property Get Height()

If ReferenzCtrl Is Nothing Then
   hoehe% = SplitterCtrl.Parent.ScaleHeight - BorderWidth% * 2
   If hoehe% < 0 Then hoehe% = 0
   Height = hoehe%
Else
   Height = ReferenzCtrl.Height
End If

End Property

Private Property Get Top()

If ReferenzCtrl Is Nothing Then
   Top = BorderWidth%
Else
   Top = ReferenzCtrl.Top
End If

End Property

Private Property Get LeftRight()

If VisibleLeft() Then
   LeftRight = SplitterCtrl.Left + SplitterCtrl.Width
Else
   LeftRight = BorderWidth%
End If

End Property

Public Sub SetLeft(Ctrl As Control, Optional v% = -1)

If SplitterCtrl.Parent.WindowState = 1 Then Exit Sub

Ctrl.Visible = VisibleLeft() = True And v% <> 0
Ctrl.Move BorderWidth%, Top(), WidthLeft(), Height()

End Sub

Public Sub SetRight(Ctrl As Control, Optional v% = -1)

If SplitterCtrl.Parent.WindowState = 1 Then Exit Sub

Ctrl.Visible = VisibleRight() = True And v% <> 0
Ctrl.Move LeftRight(), Top(), WidthRight(), Height()

End Sub

Public Sub SetSplitter()

If SplitterCtrl.Parent.WindowState = 1 Then Exit Sub

SplitterCtrl.Move Left(), Top(), SplitterCtrl.Width, Height()

End Sub
